<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Requires: class Go_Forward()
 * Shows form for editing or insert records
 * 
 * @since 2011-07
 */

class Db_Form extends Dbc
{
    protected $fields_with_alias;
    protected $field_length;
    protected $field_name;
    protected $field_type;
    protected $form_type = 'i'; // i=insert, e=edit
    protected $arr_hidden_fields = array();
    protected $arr_hidden_values = array();
    protected $arr_values_before_update = array();
    protected $now;
    protected $number_of_orders_for_address;
    protected $number_of_fields;
    protected $query;
    protected $result_qry;
    protected $arr_skipped_fields = array();
    protected $tbl;
    protected $address_change = '';

    
/*
 * Form after submit
 */
function form_after_submit() 
{
    global $tbl;
    global $tbl_pri;
    
    // uptate data
    $this->update_row($tbl);

    if($tbl == $tbl_pri)  {
        $sql = "UPDATE $tbl
        SET sales_price = (purchase_price + (purchase_price / 100 * percent_to_purchase_price))
        WHERE id = " . $_SESSION['id'];
        $this->do_sql($sql);
     }

     if ($_REQUEST['file'] == 'order_edit.php') {
        $id = $_SESSION['auf_id'];

     // set bri_id and not pos_id
     }elseif($_REQUEST['file'] == 'modul/letter/letter_edit.php') {
        $id = $_SESSION['bri_id'];
        
     }else{
         $id = $_REQUEST['id'];
     }
     
     // Forwarding
     if (isset($_SESSION['src_file']) and $_SESSION['src_file'] == 'query.php') {
         $file_to_go = 'query.php';
     }else{
         $file_to_go = $_SESSION['file'];
     }
     $go = new Go_Forward();
     $go->go_to_target($file_to_go, "&geaendert=1&tbl=".$_SESSION['tbl']);
}


/**
 * 
 */
function form_after_submit_with_copy() 
{
    global $tbl;
    // copy
     if( isset($_REQUEST['change_data']) and $_REQUEST['cp22'] == 1) {
        $data = $this->make_array_for_sql($tbl);
        $this->insert_array($tbl, $data);
        $go = new Go_Forward();
        $go->go_to_target($_SESSION['file']);
    } 

}


/**
 * Check if there is a order for this address
 * 
 */
function check_if_is_order_for_address()
{
    global $tbl_ord;
    global $html;
    
    /**
     * Check if there is a order for this address
     */
    $sql = "SELECT id FROM $tbl_ord
            WHERE id_tbl_address = " . $_SESSION['id'] . " AND payed >1";

    $number_of_orders = $this->count_rows($sql);

    $this->number_of_orders_for_address = $number_of_orders;
    return $number_of_orders;
}


/**
 *
 * @param array $arr_fields expects assoc array like "field_name => alias" 
 */
function set_fields($arr_fields)
{
    $this->fields_with_alias = $arr_fields;
    
    // Select fields for query
    if(is_array($this->fields_with_alias) and count($this->fields_with_alias)>0) {
        // Unset empty array elements
        $str_fields_without_alias = implode(',', $arr_fields);

    }else{
        $str_fields_without_alias = ' * ';
    }
    $this->str_fields_without_alias = $str_fields_without_alias;
}


/**
 *
 * @param type $array_hidden_fields 
 */
function set_hidden_fields($array_hidden_fields)
{
    $this->arr_hidden_fields = $array_hidden_fields;
}


/**
 * 
 */
function set_hidden_values($array)
{
    $this->arr_hidden_values = $array;
}


/**
 * Set fields which shouldn't be displayed
 */
function set_skipped_fields($array)
{
    $this->arr_skipped_fields = $array;
    
}


/**
 * 
 */
function split_fields($i)
{
    // Split input, two cells
    if($i == (round($this->number_of_fields/2)) and $this->number_of_fields > 14) {
        ?>
        </td><td>
        <?php
    }
    
}


/**
 * Choose which kind of form do you want to create
 * two are possible: 
 * i= insert
 * e= edit
 * a= edit all
 */
function set_form_type($type='i')
{
    $this->form_type = $type;
}

/**
 *
 * @param type $field_length
 * @return type 
 */
function set_field_length($field_length)
{
    if ($field_length > 40) {
        $long = INPUT_FIELD_WIDTH;
    }else{
        $long = $field_length + 2;
    }
    return $long;
}

/**
 *
 * @global type $tbl_adr
 * @global type $html
 * @global type $la_address_data_edit
 * @global type $la_client_warning 
 */
function print_warning_for_used_address_id()
{
    global $tbl_adr;
    global $html;
    global $info;
    global $la_address_data_edit;
    global $la_client_warning;
    /**
     * Display link to address only when no order for this address exist.
     */
    if (        $_SESSION['tbl'] == 'adr' 
            and $this->number_of_orders_for_address > 0 
            and $this->address_change != 3
            and $this->address_change != 4
        ) 
    {
        // Get client id
        $kun_id = $this->get_one_field($tbl_adr, $_SESSION['id'], 'id_tbl_client');

        // Change link to address
        $link = new Link();
        $arr = array(
            'address_change' => 3, 
            'tbl' => 'adr', 
            'kun_id' => $kun_id, 
            'file' => 'address_edit.php',
            );
        if (isset($_REQUEST['id'])) {     
            $arr['id'] = $_REQUEST['id'];
        }
        // Warning
        $text_warning = $la_client_warning;
        $text_warning .= '<br><b>';
        $text_warning .= $link->make_link( 'tbl_edit.php', $la_address_data_edit, $arr);
        $text_warning .= '</b>';
        $info->show_box($text_warning, $bg_color = '#E6E5FF', $width=600);
    }
}


function set_address_change_value()
{
    if (isset($_REQUEST['address_change'])) {
        $this->address_change = $_REQUEST['address_change'];
    }
}

/**
 * 
 */
function save_address_change_in_new_record()
{
    global $tbl;
    global $tbl_cli;
    global $tbl_adr;
    
    if ( isset($_REQUEST['address_change']) and $_REQUEST['address_change'] == 4 ) 
    {
        if ($this->number_of_orders_for_address > 0) {
            //  insert copy
            $data = $this->make_array_for_sql($tbl);
            $return_from_insert_sql = $this->insert_array($tbl, $data);

            /**
             * If insert is succsessfully, address id will be updated in 
             * table client
             */
            if ($return_from_insert_sql != false or $return_from_insert_sql == true) {
               // find last record
               $max_id = $return_from_insert_sql;

                // get array of last address id
                $address = $this->get_row_as_array($tbl, "id = $max_id");

                // write adress-id into table
                $sql = "
                    UPDATE $tbl_cli 
                    SET id_tbl_address =" . $address['id'] . " 
                    WHERE id = " . $_SESSION['kun_id'];
                $this->do_sql($sql);

                // write adress-id into table
                $sql = "
                    UPDATE $tbl_adr 
                    SET id_tbl_client =" . $_SESSION['kun_id'] . " 
                    WHERE id = LAST_INSERT_ID()";
                $this->do_sql($sql);

                $go = new Go_Forward();
                $go->go_to_target($_SESSION['file'], 'tbl='.$_SESSION['tbl'].'&id='.$max_id);
            }
        }
    }
}


/**
 *
 * @param type $type 
 */
function set_tbl_and_id($tbl, $id='')
{
    $this->query = "SELECT 
                    $this->str_fields_without_alias
                    FROM $tbl ";
    if (empty ($id)) {
        $this->query .= " LIMIT 1";
        
    }else{
        $this->query .= " WHERE id =". $id;
        
    }
    // Result of query for iterate fields
    $this->result_qry = $this->query($this->query);
    
    // Number of fields
    $this->number_of_fields = $this->count_fields($this->query);
    $this->tbl = $tbl;
}


/**
 *
 * @global type $fields
 * @param type $insert_or_edit 
 */
function iterate_fields()
{
    $row = $this->get_row_as_array_from_query($this->query);
    $this->arr_values_before_update = $row;
    
    // Read fields; $i=1 means without id
    for($i=1; $i < $this->number_of_fields; $i++) {
        $field_name = $this->get_field_name($this->result_qry, $i);
        $field_type = $this->get_field_type($this->result_qry, $i);
        $field_length = $this->get_field_len($this->result_qry, $i);
        $long = $this->set_field_length($field_length); // length of input
        $this->split_fields($i);
        
        // Get alias: class Query(), fuction get_alias()
        $alias = Query::get_alias($field_name);
        
        if ($this->form_type == 'e' or $this->form_type == 'a') {
            $field_content = $row[$field_name];
        }else{
            $field_content = '';
        }
        $this->print_field($field_name, $field_type, $field_length, $field_content, $alias, $long);
    } // end for
}


/**
 * How to display different fields
 *
 * @global type $adm
 * @global type $la_alter
 * @global type $la_category
 * @global type $la_product_id
 * @global type $la_hourly_rate
 * @global type $la_deliverer
 * @global type $arr_salutation
 * @global type $la_select_please
 * @global type $arr_tax_a_b
 * @global type $la_password_change
 * @global type $la_unit
 * @global type $la_worker
 * @global type $tbl_adr
 * @global type $tbl_cat
 * @global type $tbl_cou
 * @global type $tbl_cal_mat
 * @global type $tbl_pri
 * @global type $tbl_hou
 * @global type $tbl_ord
 * @global type $tbl_uni
 * @global type $tbl_wor
 * @global type $use
 * @global type $worker
 * @param type $field_name
 * @param type $field_type
 * @param type $field_length
 * @param type $field_content
 * @param type $alias
 * @param type $laenge
 * @return type 
 */
function print_field($field_name, $field_type, $field_length, $field_content, 
        $alias, $laenge)
{
    global $adm;
    global $la_alter;
    global $la_category;
    global $la_product_id;
    global $la_hourly_rate;
    global $la_deliverer;
    global $arr_salutation;
    global $la_select_please;
    global $arr_tax_a_b;
    global $la_password_change;
    global $la_unit;
    global $la_worker;
    global $tbl_adr;
    global $tbl_cat;
    global $tbl_cou;
    global $tbl_cal_mat;
    global $tbl_pri;
    global $tbl_hou;
    global $tbl_ord;
    global $tbl_uni;
    global $tbl_wor;
    global $use;
    global $worker;
    
    $html = new Html_Element();
    $drop = new Drop_Down();
    $drop->set_condition('hide != 1');

    // Edit all fields
    if ($this->form_type == 'a') {
        ?>
        <input type="text" size="<?php print $laenge; ?>"
               name="<?php print $field_name; ?>"
               value="<?php print $field_content; ?>"
               maxlength="<?php print $field_length; ?>" > <?php
               print $alias; ?><br/>
        <?php
        return true;
    }

    // If skipped fields, return false
    if (in_array($field_name, $this->arr_skipped_fields)) {
        return false;
    }
       
    // If hidden field, make hidden field and return true
    $key = array_search($field_name, $this->arr_hidden_fields);
    if ($key !== false and isset($this->arr_hidden_values[$key])) {
        print $html->input(1, 'hidden', $field_name, $this->arr_hidden_values[$key]);
        return true;
    }
       
    /**
    * How to display each field (blob, int, varchar etc.)
    */
    if ($field_type == 'blob' or $field_length > 100) {
        if (empty($worker['textarea_rows'])) {
            $textarea_rows = 6;
        }else{
            $textarea_rows = $worker['textarea_rows']*4;
        }
        ?>
    
        <textarea name="<?php print $field_name; ?>" cols="90%"
                  rows="<?php print $textarea_rows; ?>"
    ><?php print $field_content; ?></textarea> <?php print $alias; ?>
    <?php

    // order_conf date_insert vorausfuellen
    }elseif($field_name == 'date_offer' and
        (isset($_POST['date_name']) and $_POST['date_name'] == 'offer')) {
    ?>
    <input class="red" type="text" size="10" name="<?php print $field_name; ?>"
           value="<?php print $aktuelles_datum; ?>">
    <script language="JavaScript">
    new tcal ({
        // form name
        'formname': 'teo',
        // input name
        'controlname': '<?php print $field_name; ?>'
    });

        </script>
    <?php print $field_name; ?> <span class="red">
    <?php print $la_akt_dat_vorausgef; ?></span>
    <?php

    // Get order_conf date to prepopulate (vorausfuellung)
    }elseif($field_name == 'date_order_conf' 
            and (isset($_POST['date_name']) and $_POST['date_name'] == 'order_conf')) 
    {
        print '<input class="red" type="text" size="10" name="$feldname"'
        . 'value="' . $aktuelles_datum . '">' . $field_name 
        . '<span class="red">' . $la_akt_dat_vorausgef . '</span><br/>';

    // Delivery date prepopulate
    }elseif($field_name == 'delivered' and
        ( isset($_POST['date_name']) and $_POST['date_name'] == 'delivered') ) {
    ?>
    <input class="red" type="text" size="10" name="<?php print $field_name; ?>"
           value="<?php print $aktuelles_datum; ?>"> <?php print $field_name; ?>
    <span class="red"><?php print $la_akt_dat_vorausgef; ?></span>
    <?php

    // Invoice date prepopulate
    }elseif($field_name == 'date_invoice' and 
        (isset($_POST['date_name']) and $_POST['date_name'] == 'invoice')) {
    ?>
    <input class="red" type="text" size="10" name="<?php print $field_name; ?>"
           value="<?php print $aktuelles_datum; ?>"> <?php print $field_name; ?>
    <span class="red">Aktuelles Datum vorausgefllt</span>
    <?php

    // Drop down categorie
    }elseif ($field_name == 'id_tbl_category' or $field_name == $la_category) {
        $this->select_db($use['db_e']);
        $arr_fields = array('category');
        $drop->set_values_db($tbl_cat, $field_name, $arr_fields, $field_content);
        print $drop->make_drop_down(0);

    // Salutation
    }elseif ($field_name == 'id_tbl_salutation') {
        if ($this->number_of_orders_for_address > 0 and !isset ($_REQUEST['cop']) 
                and $this->address_change != 3) 
        {
            $drop->set_drop_down_inactive(1);
        }
        $drop->set_values_array($field_name, $arr_salutation, $field_content);
        print $drop->make_drop_down(1);

    // Tax
    }elseif ($field_name == 'tax_a_b') {
        $drop->set_values_array($field_name, $arr_tax_a_b, $field_content);
        print $drop->make_drop_down(1);

    // Country
    }elseif ($field_name == 'id_tbl_country') {
        if ($this->form_type == 'i') {
            $field_content = $adm['id_tbl_country'];
        }
        if ($this->number_of_orders_for_address > 0 and $this->address_change != 3) {
            $drop->set_drop_down_inactive(1);
        }
        $this->select_db();
        $arr_fields = array('country');
        $drop->set_values_db($tbl_cou, $field_name, $arr_fields, $field_content);
        print $drop->make_drop_down(1);
        // Switch database important!
        $this->select_db($use['db_e']);

    // Dropdown field unit
    }elseif($field_name == 'id_tbl_unit' ) {
        $arr_fields = array('unit');
        $drop->set_condition(1);
        $drop->set_values_db($tbl_uni, $field_name, $arr_fields, $field_content);
        print $drop->make_drop_down(1);
        
    // Bool fields
    }elseif ( $field_type == 'int' and $field_length == 1 and $field_name != 'edge' ) {
        print $html->html_checkbox(1, $field_name, $field_content);
        print ' ' . $alias;

    // Operator
    }elseif ($field_name == 'id_tbl_worker') {
        $this->select_db($use['db_e']);
        $arr_fields = array('username', 'surname');
        $drop->set_values_db($tbl_wor, $field_name, $arr_fields, $field_content);
        print $drop->make_drop_down(1);

    // Hourly rates
    }elseif ($field_name == 'id_tbl_hourly_rate' or $field_name == $la_hourly_rate) {
        $this->select_db($use['db_e']);
        $arr_fields = array('short','money_hour');
        $drop->set_values_db($tbl_hou, $field_name, $arr_fields, $field_content);
        print $drop->make_drop_down(1);

    // Number
    }elseif ($field_name == 'number') {
        $this->select_db($use['db_e']);
        if($adm['own_doc_number'] == 1) {
            // When insert max number + 1
            if ($this->form_type == 'i') {
                $field_content = $this->get_max($tbl_ord, 'number')+1;
            }
            print $html->input(1, 'text', $field_name, $field_content, $laenge, 
                    $field_name, $field_length);
        }

    // Date2
    }elseif ($field_name == 'date2' and $this->form_type == 'i') {
        // When insert max number + 1
        $this->get_today_date();
        $field_content = $this->now;
        ?>
        <input type="text" size="10" name="<?php print $field_name; ?>"
        value="<?php print $field_content; ?>">
        <script language="JavaScript">
            new tcal ({
                // form name
                'formname': 'teo',
                // input name
                'controlname': 'date2'
            });
        </script> Datum
            <?php

    // Order item
    }elseif ($field_name == 'id_tbl_order_item') {
        print $html->input(1, 'hidden', $field_name, $field_content);

    // Password
    }elseif ($field_name == 'pw') {
        ?>
        <input type="text" size="<?php print $laenge; ?>"
               name="<?php print $field_name; ?>"
           value="<?php print $field_content; ?>"> <?php print $alias; ?><br/>
        <?php
        $link = new Link();
        $arr = array('id' => $_REQUEST['id']);
        print  $link->make_link( 'pw_edit.php', $la_password_change, $arr);


    // Sales price
    }elseif ($field_name == 'sales_price' and $this->tbl == $tbl_pri) {
        ?>
        <input type="text" readonly="readonly" name="<?php print $field_name; ?>"
               value="<?php print $field_content; ?>"> <?php print $alias; ?>
        <?php

    /**
     * For change address, readonly fields
     * 
     * Dont change this fields, when this address belongs to an 
     * finished order
     */
    } elseif (
                (  
                    ($field_name == 'surname' and $this->tbl != $tbl_wor) 
                    or ($field_name == 'forename' and $this->tbl != $tbl_wor) 
                    or $field_name == 'city' 
                    or $field_name == 'company' 
                    or $field_name == 'street' 
                    or $field_name == 'country' 
                    or $field_name == 'id_tbl_address' 
                    or $field_name == 'id_tbl_client' 
                    or $field_name == 'postcode' 
                    or $field_name == 'addition' 
                    or $field_type == 'timestamp'
                ) 
                and $this->number_of_orders_for_address > 0 
                and $this->address_change != 3
            ) 
    {
        ?>
        <input type="text" readonly="readonly" size="<?php print $laenge; ?>"
               name="<?php print $field_name; ?>"
               value="<?php print $field_content; ?>"
               maxlength="<?php print $field_length + 1; ?>"
               ><?php
               print $alias; ?>
        <?php
            
            
    // All other fields
    }else{
        ?>
        <input type="text" size="<?php print $laenge; ?>"
               name="<?php print $field_name; ?>"
               value="<?php print $field_content; ?>"
               maxlength="<?php print $field_length + 1; ?>" > <?php
               print $alias; ?>
        <?php
    }
    print '<br/>';
}


/**
 * Today date formated
 */
function get_today_date() {
    $timestamp = time();
    $aktuelles_datum = date("Y-m-d", $timestamp);
    $this->now = $aktuelles_datum;
}

} // end class
