<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Class for MySQL connection
 * 
 * Requires: 
 *  class HTML, 
 *  class Query
 *  function link_back_with_query
 */
class Dbc 
{
protected $last_error = false; // last MYSQL error
protected $last_query; // last query
protected $row_count; // amount of records
protected $host; // host f.e. pdb1.pretago.de
protected $user; // username
protected $pw; // password
protected $db; // database
protected $db_resource; // db connection identifier

/**
 * Sets the database parameters
 * 
 * @param string $db database
 */
function __construct($db = '') 
{
    global $use;
    
    $this->host = DB_HOST;
    $this->user = DB_USER;
    $this->pw = DB_PW;
    
    if (empty ($db)) {
        $this->db = DB_NAME;
    }else{
        $this->db = $db;
    }
    
    // Connection to database
    $this->db_resource = mysql_connect($this->host, $this->user, $this->pw) or
            die('<p>Connection Error</p>');
    $this->db_resource = mysql_select_db($this->db);
}


/**
 * Executes query with mysql_query() and returns the result
 * 
 * @param string $sql SQL-Abfrage
 * @return <type> $result Ergebnis
 */
function query($sql) 
{
    $this->last_query = $sql;
    $result = mysql_query($sql);
    $this->db_error_handler($result);

    return $result;
}


/**
 *
 * @param type $db
 * @return type 
 */
function select_db($db=DB_NAME) 
{
    $this->db = $db;
    if (mysql_select_db($this->db)) {
        return true;
    }else{
        return false;
    }

}

/**
 * Inserts data in the database via SQL query.
 * 
 * @param string $sql
 * @return mixed boolean true/false or last_insert_id()
 */
function insert_sql($sql) 
{
    $this->query($sql);
    $id = mysql_insert_id();
    if ($id == 0) {
        return true;
    }else{
        return $id;
    }
}


/**
 * Alter values in the database
 * 
 * @param string $sql
 * @return mixed true if affected rows = 0 else returns affected rows
 */
function do_sql($sql) 
{
    $this->query($sql);
    $rows = mysql_affected_rows();
    $this->do_sql_log();
    if ($rows == 0) {
        return true;  // no rows were updated
    } else { 
        return $rows; 
    }
}


/**
 * Log with querys for finding errors
 * 
 * @global type $use
 * @global type $error_first_line 
 */
function do_sql_log() 
{
    global $use;
    global $error_first_line;
    
    $file = fopen(QUERY_LOGFILE_PATH, 'a');
    // Insert error message
    $query = $error_first_line . " | " . $this->last_query . " | "
            . ' ' . $_SERVER['SCRIPT_NAME'] . "\r\n";

    fwrite($file, $query);
    fclose($file);
}


/**
 * Creates a SQL-string for updating a record
 * 
 * @param string $table
 * @param array $arr_data
 * @return string
 */
function insert_array($table, $arr_data) 
{
    if (empty($arr_data)) {
        $this->last_error = 'No array.';
        return false;
    }

    $cols = '(';
    $values = '(';

    foreach ($arr_data as $key=>$value) {
     $cols .= "$key, ";
     $values .= "$value, ";
    }

    $cols = rtrim($cols, ', ') . ')';
    $values = rtrim($values, ', ') . ')';

    // insert values
    $sql = "INSERT INTO $table $cols VALUES $values";

    return $this->insert_sql($sql);
}
 

/**
 * Updates a record form a assoc array
 * 
 * @param string $table
 * @param array $data
 * @param string $condition
 * @return mixed boolean or number of affected rows
 */
function update_array($table, $data, $condition) 
{
    if (empty($data) or !is_array($data)) {
        $this->last_error = 'Keine Daten vorhanden oder Daten sind kein Array.';
        return false;
    }

    $sql = "UPDATE $table SET";
    foreach ($data as $key=>$value) { 
        $sql .= " $key=";
        $sql .= "$value,";
    }
    $sql = rtrim($sql, ','); // strip off last "extra" comma
    if (!empty($condition)) $sql .= " WHERE $condition";
        $this->last_query = $sql;
        
    return $this->do_sql($sql);
}


/**
 * Error handler for displaying errors
 * @param type $result 
 */
function db_error_handler($result=1) 
{
    if (!$result) {
        $this->last_error = mysql_error();
        $this->do_log();
        
        // Print errors only when DB_ERROR == true (for developers)
        if ( DB_ERROR == true) {
            $this->print_last_error();
            
        // Hint on the sreen for user
        }else{
            $error = substr($this->last_error, 0, 80).'...';
            $msg = "Im Programm ist ein Fehler aufgetreten und wurde soeben 
                festgehalten. Wenn Sie uns helfen m&ouml;chten den Fehler zu 
                beheben, schicken Sie uns bitte diese E-Mail (auch ohne Inhalt): 
                <br/><a href=\"mailto:info@schreinerwissen.de?subject=$error\">
                E-Mail schicken</a>
            ";
           $this->print_last_error_msg($msg);
        }
        
    }
    $this->last_error = false;
}


/**
 * Prints the last message for user
 * 
 * @global type $css
 * @param type $message 
 */
function print_last_error_msg($message) 
{
    global $css;
    HTML::printHead($css);
    HTML::printBody();
    print link_back_with_query();
    $info = new Info_Box();
    $info->set_color('red');
    $info->show_box($message);
    html::printFoot();
    exit();
}


/**
 *  Takes the last field
 */
function take_last_field($tbl) 
{
    // To be implemented in child class
}


/**
 * read post data and array ($a) for update of record
 * condition: the primary key is on the first position ($i = 0)
 * 
 * Array-Muster: [forename] => 'Heinrich'
 * @param string $tbl
 * @return array values for update
 */
function make_array_for_sql($tbl)
{
    $sql = "SELECT * FROM $tbl LIMIT 1";
    $result = $this->query($sql);
    $this->last_query = $sql;
    
    $number_of_fields = mysql_num_fields($result);
    $arr = array();
    // $i=1 => without id
    for($i=1; $i< $number_of_fields; $i++) {
        $field_name = mysql_field_name($result, $i);
        $field_type = mysql_field_type($result, $i);

        // Don't change the ID
        if (isset($_REQUEST[$field_name])) {

            // Gets the last value, if a special charakter is in the input field
            if($_REQUEST[$field_name] == TAKE_LAST_FIELD) {
                $this->take_last_field($tbl);

            }else{
                // check, if escaped on the server
                if(get_magic_quotes_gpc()) {
                    $field_value = stripslashes($_REQUEST[$field_name]);
                } else {
                    $field_value = $_REQUEST[$field_name];
                }
            }

            // fill array values with or without quotes
            $arr = $this->set_quotes_or_not($field_value, $field_type, $field_name, $arr);
        }
    }
    return $arr;
}


/**
 * Fills array for update or insert
 * 
 * @param type $field_value
 * @param string $field_type
 * @param type $field_name
 * @param type $arr
 * @return string 
 */
private function set_quotes_or_not($field_value, $field_type, $field_name, $arr) 
{
    // mask dangerous charakters from input
    $field_value = mysql_real_escape_string($field_value);
    
    if ($field_type == 'real' or $field_type == 'int') {
        if (!is_numeric($field_value)) {
            #$query = new Query();
            $field_name_msg = Query::get_alias($field_name);
        }
        
        // REAL: change comma to point if fieldtype is double /real
        if($field_type == 'real') {
            // Change comma to point
            $field_value =  str_replace(",", ".", $field_value);
            // Check if input has correct value (empty value is ok)
            if (!is_numeric($field_value) and !empty($field_value)) {
                    $message = 'Im Feld "' . $field_name_msg 
                            . '" bitte nur ganze Zahlen oder Dezimalzahlen eingeben.';
            }
            // round with 2 decimal places when unit is not "m3" (m3=id 6)
            if (        $field_name == 'amount' 
                    and (isset($_REQUEST['id_tbl_unit']) 
                    and $_REQUEST['id_tbl_unit'] != 6) ) 
            {
                $field_value = round($field_value, 2);
            }
        }    

        // INT: Check if input has correct value (empty value is ok)
        if ($field_type == 'int' and !is_numeric($field_value) and !empty($field_value)) {
                $message = 'Im Feld "' . $field_name_msg . '" bitte nur ganze Zahlen eingeben.';
        }
        
        // prevent empty values, otherwise error
        if (empty($field_value)) {
            $arr[$field_name] = 0;
        }else{
            $arr[$field_name] = $field_value;
        }

    // Not real or int: Text in quotes
    }else{
        $arr[$field_name] = "'" . $field_value . "'";
    } 

    if (!empty ($message)) {
        $this->print_last_error_msg($message);
    }
    return $arr;
}


/**
 * Gets the value from one field of the record
 * 
 * @param str $tbl Name der Tabelle
 * @param int $id id from record
 * @param str $field Name of field
 */
function get_one_field($tbl, $id, $field) 
{
    // IMPORTANT: '$id' in quotes is necessary for id = 'DE' !
    $sql = "SELECT " . $field . " FROM " . $tbl . " WHERE id = '" . $id . "'"; 
    $result= $this->query($sql);
    $number_of_rows = mysql_num_rows($result);
    if ($number_of_rows > 0) {
        $field_value = mysql_result($result, 0);
        return $field_value;
    }else{
        return '';
    }
}


/**
 * Gets maximal value from a query
 * 
 * @param str $table Table
 * @param str $field Field name for maximum
 * @param str $condition String der nach WHERE steht
*/
function get_max($table, $field, $condition=1) 
{
    $sql = "SELECT MAX($field) FROM $table WHERE $condition" ;
    $result = $this->query($sql);
    $max = mysql_result($result, 0);
    return $max;
}


/**
 * Gets minimum value from a query
 * 
 * @param str $table Table
 * @param str $field Field name for maximum
 * @param str $condition String der nach WHERE steht
*/
function get_min($table, $field, $condition=1) 
{
    $sql = "SELECT MIN($field) FROM $table WHERE $condition" ;
    $result = $this->query($sql);
    $min = mysql_result($result, 0);
    return $min;
}


/**
 * Counts records from a query
 *
 * @param string $query mysql-query
 * @return int  
 */
function count_rows($query)
{
    $result = $this->query($query);
    return mysql_num_rows($result);
}

/**
 * Counts records from a query
 *
 * @param string $query mysql-query
 * @return int  
 */
function count_fields($query)
{
    $result = $this->query($query);
    return mysql_num_fields($result);
}

/**
 * Gets the field name
 *
 * @param string $query mysql-query
 * @return int  
 */
function get_field_name($result, $i)
{
    return mysql_field_name($result, $i);
}

/**
 * Gets the field type
 *
 * @param string $query mysql-query
 * @return int  
 */
function get_field_type($result, $i)
{
    return mysql_field_type($result, $i);
}

/**
 * Gets the field length
 *
 * @param string $query mysql-query
 * @return int  
 */
function get_field_len($result, $i)
{
    return mysql_field_len($result, $i);
}


/**
 * Gets one record as array
 * 
 * @param str $tbl table
 * @param str $condition SQL-condition after WHERE, f.i. "id='$_SESSION['id']'"
 * @param string $type array or assoc, array is default
 * @return arr $arr array with values of the record
 */
function get_row_as_array($tbl, $condition, $type='array') 
{
    $sql = "SELECT * FROM $tbl WHERE $condition";
    $result = $this->query($sql);
    if ($type == 'array') {
        $arr = mysql_fetch_array($result);
        
    }  elseif ($type == 'assoc') {
        $arr = mysql_fetch_assoc($result);
        
    }  elseif ($type == 'object') {
        $arr = mysql_fetch_object($result);
    }
    return $arr;
}


/**
 * Gets one record as array
 * 
 * @param str $tbl table
 * @param str $condition SQL-condition after WHERE, f.i. "id='$_SESSION['id']'"
 * @param string $type array or assoc, array is default
 * @return arr $arr array with values of the record
 */
function get_row_as_array_from_query($query, $type='array') 
{
    $result = $this->query($query);
    if ($type == 'array') {
        $arr = mysql_fetch_array($result);
        
    }  elseif ($type == 'assoc') {
        $arr = mysql_fetch_assoc($result);
    }
    return $arr;
}


/**
 * Gets one record as array
 * 
 * @param str $tbl table
 * @param str $condition SQL-condition after WHERE, f.i. "id='$_SESSION['id']'"
 * @param string $type array or assoc, array is default
 * @return arr $arr array with values of the record
 */
function fetch_array($result, $type='array') 
{
    if ($type == 'array') {
        $arr = mysql_fetch_array($result);
        
    }  elseif ($type == 'assoc') {
        $arr = mysql_fetch_assoc($result);
    }
    return $arr;
}


/**
 * This function combine make_array_for_update and update array
 *
 * @param type $tbl
 * @return boolean
 */
function update_row($tbl) 
{
    if (isset ($_REQUEST['change_data'])) {
        $arr = $this->make_array_for_sql($tbl);
        $this->update_array($tbl, $arr, "id = ".$_REQUEST['id']);
        return true;
    }
}


/**
 * This function outline (combine) make_array and insert_array for inserting
 *
 * @param type $tbl
 * @return type 
 */
function insert_row($tbl) 
{
    // insert data
    if (isset ($_REQUEST['insert_data'])) {
        if (isset ($_REQUEST['check_id'])) {
            if (!isset($_SESSION['check_id'])) {
                $_SESSION['check_id'] = '';
            }
            // prevent double submitted forms
            if ($_SESSION['check_id'] != $_REQUEST['check_id']) {
                $_SESSION['check_id'] = $_REQUEST['check_id'];
                $in_arr = $this->make_array_for_sql($tbl);
                // Insert array and get last_insert_id
                $last_insert_id = $this->insert_array($tbl, $in_arr);
                return $last_insert_id;
            }else{
                print '<p class="error">Fehler: doppeltes Versenden des Formulars</p>';
                return false;
            }
        }else{
            print 'check_id fehlt';
            return false;
        }
    }
}



/**
 * Prints the last error
 */
function print_last_error() 
{
    $message = $this->last_error .'<br>' . $_SERVER['SCRIPT_NAME'];
    $this->print_last_error_msg($message);
}

/**
 *  Prints the last query
 */
function print_last_query() 
{
    $message = $this->last_query;
    $this->print_last_error_msg($message);
}


/**
 * Writes sql-errors to the log file
 * 
 * @global type $use
 * @global type $css 
 */
function do_log() 
{
    global $use;
    global $css;
    global $error_first_line;
    
    if ($this->last_error == true) {
        $file = basename($_SERVER['PHP_SELF']);
        // Input for error.log
        $text_error_log = $error_first_line . $this->last_error . "\n\t" 
                        . $this->last_query . '| ' . $file . "\n ";
         
        $las_err = error_get_last();
        if (is_array($las_err)) {
            foreach ($las_err as $key => $value) {
                $text_error_log = $error_first_line . $las_err['type'] . ', ' . $las_err['message']
                                . ' in file ' . $las_err['file'] . ' on line '
                                . $las_err['line'] . "\n";
            }
        }
        HTML::printHead($css);
        HTML::printBody();

        #error_log($text_error_log, 3, PROJECT_DOCUMENT_ROOT.'/error.log');
    }
}

} // end class
