<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Display data in a table for selecting rows.
 * 
 * Table address: shows a menubar 
 * 
 * @since 06/2011
 */

class Row_Select extends Tbl
{
    // Source table with data you ar looking for.
    protected $tbl_src;
    
    // Fields wich are displayed in the table
    protected $tbl_src_fields = array();
    
    // Keyword for the search, f.i. searching delivery address: "select_deliverer"
    protected $link_keyword;
    
    
    
    /**
     * Shows the source table with all content for select a row
     * 
     * @global type $rel_order_address_delivery 
     */
function show_tbl_src()
{
    global $rel_order_address_delivery;
    
    // create string with fields for sql-query
    $fields_str = implode(", ", $this->tbl_src_fields);
    if(isset($_SESSION['value1'])) {
        $value1 = $_SESSION['value1'];
    }else{
        $value1 = '';
    }
    
    $search_string_from_value1 = $this->search_string_many_words($value1, $this->tbl_src_fields);

    if (isset($_SESSION[$this->link_keyword]) and $_SESSION[$this->link_keyword] == 'used') {
        // Delivery addresses
        $this->tbl_src_fields = array(
            'adr.id',
            'id_tbl_address',
            'id_tbl_address_deliv',
            'company',
            'surname',
            'postcode',
            'city',
            'street',
            'adr.hide',
        );
    $fields_str = implode(", ", $this->tbl_src_fields);
        $sql = "
            SELECT DISTINCT $fields_str
            FROM $rel_order_address_delivery
            WHERE id_tbl_address = " . $_SESSION['adr_id'] 
            . " AND id_tbl_address_deliv != 0 ";
      
    }else{
        $sql = "SELECT $fields_str 
                FROM $this->tbl_src 
                WHERE $search_string_from_value1 
                AND hide != 1";
    }
    $this->set_query($sql);
    $this->set_fields($this->tbl_src_fields);
    $this->show_table();
    
}


/**
 *
 * @global type $la_cancel
 * @return string html-link
 */
function make_link_cancel()
{
    global $la_cancel;
    
    // Change link to address
    $link = new Link();
    $arr = array(
        'cancel' => 1
        );
    $target = PROJECT_HTTP_ROOT . $_SESSION['src_file'];
   return $link->make_link( $_SESSION['src_file'], $la_cancel, $arr);
}


/**
 * 
 */
function print_head()
{
    global $file;
        // Cancel for leave this class
    if (isset($_GET['cancel']) and $_GET['cancel'] == 1) {
        unset($_SESSION[$this->link_keyword]);
        $go = new Go_Forward();
        $go->go_to_target($file);
    }
    HTML::printHead('default.css');
    HTML::printBody();
}

/**
 * 
 */
function print_foot()
{
    HTML::printFoot();
    exit;
}


/**
 * Menu line for select deliverer and select text
 */
function print_menu($headline, $deliv_or_text)
{
    global $file;
    global $la_text_default;
    
    print '<div class="menux">';
    print $this->make_link_cancel();
    print $this->make_link_without();
    if ($deliv_or_text == 'deliv') {
        print $this->make_link_used_rows();
        
    }  else {
        // standard text -> value=1
        $link = new Link();
        $arr = array (
            'text_id' => 1, 
            'select_text' => 'selected',
            );
        print $link->make_link($file, $la_text_default, $arr);
    }
    print '</div>';
    print '<div>';
    print $headline;
    print '</div>';
    if ($deliv_or_text == 'deliv') {
        print search_form($file, 1);
    }
}


/**
 * Prints a link "select nothing"
 *
 * @global str $file
 * @global str $la_select_nothing
 * @return str 
 */
function make_link_without()
{
    global $file;
    global $la_select_nothing;

    // Change link to address
    $link = new Link();
    $arr = array(
        $this->link_keyword => 'selected',
        $this->id_name_link => 0,
        );
       return $link->make_link( $file, $la_select_nothing, $arr);
}


/**
 * @todo
 */
function make_link_used_rows()
{
    global $file;

    // Change link to address
    $link = new Link();
    $arr = array(
        $this->link_keyword => '', 
        'tbl'=> 'adr', 
        'select_deliverer' => 'used',
        $this->id_name_link => 0,
        'go' => 1,
        );
    return $link->make_link( $file, 'Bereits verwendete Lieferadressen anzeigen.', $arr);
}


/**
 * Makes a querystring from a string with more than one word
 * separated with space
 * 
 * @param string $value1
 * @param array $fields
 * @return string 
 */
function search_string_many_words($value1, $fields) 
{
    // Creates an array from the search string, separation: space
    $wert1_ar = explode(' ', $value1); 
    $query = '';
    
    // Iterate values
    foreach($wert1_ar as $z) {
        $query .= "(";
        $total_fields = count($fields);
        
        // Iterate fields and connect with OR
        for($i=0; $i< $total_fields; $i++) {
            $query .= "$fields[$i]" . " LIKE '%" . $z . "%' OR ";
        }
        
    // Cut OR from the end of the query string
        $query = substr($query, 0, -4);
        $query .= ") AND ";
    }
    // Cut AND from the end of the query string
    return substr($query, 0, -5);
}


/**
 * 
 */
function set_link_keyword($link_keyword)
{
    $this->link_keyword = $link_keyword;
}


/**
 * 
 */
function set_tbl_src($tbl_src)
{
    $this->tbl_src = $tbl_src;
}


/**
 * 
 */
function set_tbl_src_fields($array)
{
    $this->tbl_src_fields = $array;
}


} // end class