<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Shows the different documents in a html page
 */

require_once 'common.php';


// insert data
if (isset($_POST['insert_data'])) {
    $db->insert_row($tbl);
    $go = new Go_Forward();
    $go->go_to_target($file);
}

if ($adm['own_doc_number'] == 1 and isset ($_POST['id_or_nr'])) {
    $id_or_nr = 'number';
}else{
    $id_or_nr = 'id';
}

if ($adm['own_doc_number'] == 1) {
    $id_nr = 'number';
}else{
    $id_nr = 'id';
}

// Offer
if ($_SESSION['dok'] == 'offer') {
    $la_document = $la_offer;
    $text_field_bottom = 'offer_bottom';
    $text_bottom = $la_offer_bottom_content;

// Order confirmation
}  elseif ($_SESSION['dok'] == 'confi') {
    $la_document = $la_order_conf;
    $text_field_bottom = 'order_conf_bottom';
    $text_bottom = $la_ab_un;

// Will to pay
}  elseif ($_SESSION['dok'] == 'assum') {
    $la_document = $la_kostenuebernahme1;
    $text_field_bottom = 'assumption_costs_bottom';
    $text_bottom = $la_assumption_costs_bottom_long;

// Delivery note
}  elseif ($_SESSION['dok'] == 'deliv') {
    $la_document = $la_delivery_note;
    $text_field_bottom = 'delivery_bottom';
    $text_bottom = $la_li_un;

// Invoice
}  elseif ($_SESSION['dok'] == 'invoi') {
    $la_document = $la_invoice;
    $text_field_bottom = 'invoice_bottom';
    $text_bottom = $la_invoice_bottom;

// Part payment
}  elseif ($_SESSION['dok'] == 'partp') {
    $la_document = $la_partpay;
    $text_field_bottom = 'invoice_bottom';
    $text_bottom = $la_invoice_bottom;

// Labels
}  elseif ($_SESSION['dok'] == 'eti') {
    $la_document = $la_partpay_invoice;
    $text_field_bottom = 'invoice_bottom';
}

$document = $_SESSION['dok'];

// File name with query string and dok value
$file_with_value = $file . '?dok=' . $document;

/**
 * Form after submit
 */
if (isset($_REQUEST['change_data'])) {
    $tbl = $tbl_ord_ite;
    if ($_REQUEST['tbl'] == 'ord') {
        $tbl = $tbl_ord;
    }
    // uptate data
    $db->update_row($tbl);
    $go = new Go_Forward();
    $go->go_to_target($file_with_value);  
}

HTML::printHead($css);
HTML::printBody();
HTML::printHeadline($headline);

require_once 'include/bar_common.inc.php';
require_once 'include/bar_order.inc.php';
?>

<div id="tab">

<?php
/**
 * Label
 */
$label_inc = 'modul/label/label.inc.php';
if (is_file($label_inc)) {
    require_once $label_inc;
}


// Get client data as array like $kun3['surname'] etc.
$client = $db->get_row_as_array($tbl_adr, "id = " . $order['id_tbl_address']);

$info = new Info_Box();
$condition = ($order['part_pay_amount'] > 0 and $order['part_pay_payed'] < 1 
        and $_SESSION['dok'] == 'invoice');
$info->set_condition($condition);
$info->set_inline(true);
$info->show_box($la_partpay_info);

/**
 * Part payment
 */
if (        $order['part_pay_amount'] == 0 
        and !isset ($_REQUEST['partp']) 
        and $document == 'partp'
   ) 
{
     // array with get parameters
    $arr = array( 
        'partp' => 1, 
        'dok' => 'partp', 
        );
    print '<br/>';
    $link->set_class('bold');
    print $link->make_link($file, $la_partpay.' eintragen', $arr);
    print '</div></div>';
    HTML::printFoot();
    exit();
}

/**
 * Text bottom
 * 
 */
 // If text field in tbl_order is zero
$file5 = 'article_select.php';

if (empty($order[$text_field_bottom]) ) {
    $arr2['src_file'] = $file;
    $arr2['tbl'] = 'ord';
    $arr2['text_art'] = $text_field_bottom;
    $arr2['select_text'] = 1;
    $arr2['id'] = $_SESSION['auf_id'];
    $link_for_text = $link->make_link($file5, $la_text_select, $arr2);
    
    print '<span>'. $link_for_text . '</span>'; 


/**
 * If not, display the text
 */
}else{
    // Default
    if ($order[$text_field_bottom] == 1) {
        // text
        $text_bottom_for_displaying = nl2br($text_bottom);
    }else{
        // text from table
       $tex = $db->get_row_as_array($tbl_tex, 'id =' . $order[$text_field_bottom]);
       if (!empty($tex)) {
           $text_bottom_for_displaying = $tex['text_block'];
       }else{
           $text_bottom_for_displaying = '';
       }
    }
    $text_bottom_blue = '<span class="blue">' . $text_bottom_for_displaying . '</span>';
    
    // Link for changing text
    // modus 1 = eintragen, modus 2 = ?ndern
    $arr = array();
    $arr['modus'] = 'tausch';
    $arr['text_art'] = $text_field_bottom;
    $arr['src_file'] = $file_with_value;
    $arr['tbl'] = 'ord';
    $arr['select_text'] = 1;
    $arr['new'] = 1; // makes unset SESSION['value1']
    $link_change = $link->make_link($file5, $la_change, $arr);
    ?>

    <table style="width:auto; max-width:600px">
        <tr>
            <td>
                <?php  print nl2br($text_bottom_blue); ?>
            </td>
            <td>
                <?php print  $link_change; ?>
            </td>
        </tr>
    </table>
    <?php
    }

    /**
     * Partpayment
     */
    if ($document == 'partp') {
        // Array tax
        $arr_a_b = array(
            0 => '-',
            1 => $order['tax_rate_a'] . '%',
            2 => $order['tax_rate_b'] . '%',
            );
        $drop = new Drop_Down($use['db_e']);
        $drop->set_values_array('part_pay_tax_a_b', $arr_a_b, $order['part_pay_tax_a_b']);
        ?>
    
        <form name="namexx" method="post" action="<?php print $file; ?>">
        <input type="text" name="part_pay_description" value="<?php print $order['part_pay_description']; ?>" size="80" >
        <?php print $la_partpay_text; ?>
        <br>
        <input type="text" name="part_pay_amount" value="<?php print $order['part_pay_amount']; ?>" size="7">
        <?php print $adm['currency'] . ' ' . $la_net; ?>
        <br>
        <?php
        print $drop->make_drop_down(0);
        print $la_tax;
        ?>
        <br>
        <input type="hidden" name="tbl" value="ord">
        <input type="hidden" name="id" value="<?php print $order['id']; ?>">
        <input type="hidden" name="dok" value="<?php print $document; ?>">
        <input type="submit" value="<?php print $la_save; ?>" name="change_data">
        </form>
        <br>
        <?php
    }

?>
<div id="brief">
    <div id="regarding">
        <?php
        // There is no field kue in table order
        if ($document == 'assum') {
            $document = 'invoi';
        }
        ?>
    </div>
    
    
    <style type="text/css">
    #firma_daten {
        position: absolute;
        height: auto;
        right: auto;
        bottom: auto;
        left: 60%;
        top: 290px;
    }
</style>
    <?php 
    $invoice = new Doc_Html($use['db_e']);
    $invoice->set_data($_SESSION['auf_id'], $document);
    $invoice->set_output_format('h');
    $invoice->make_head();
?>
<div>
<table>
<tr style="background-color: transparent;">
    <td style="width: 50%; ">
        <?php
        print $invoice->make_html_delivery_address();
        print $invoice->make_html_address();
        ?>
    </td>  
    <td style="width: 50%; background-color: transparent ;">
        <?php
        print $invoice->make_html_head();
        ?>
    </td>  
</tr>
</table>
</div>
<?php
    $invoice->print_delivery_date();
    ?>

    <div id="inhalt">
        <table border="1" style="width: 160mm;" >
            <?php
            // All items, sum and sum-total
            $invoice->print_totals();
            ?>
        </table>
        <?php
        $invoice->print_abbreviations();
        $invoice->print_tax_invoice_included();
        $invoice->print_delivery_time();
        $invoice->make_text();
        $invoice->print_text('class="blue"');
        $invoice->print_small_businessman();
        $invoice->print_bank_and_aim();
        ?>
    </div>
</div>

<?php
HTML::printFoot();
?>