<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Shows query results in a table
 */

require_once 'common.php';
$remaining_logins = 'development/remaining_logins.inc.php';
if(is_file($remaining_logins)) {
	require_once 'development/remaining_logins.inc.php';
}


HTML::printHead($css);
HTML::printBody('such.value1');
HTML::printHeadline($headline);

// adr_old loeschen
if (isset($_REQUEST['new'])) {
    unset($_SESSION['todo']);
    unset ($_SESSION['adr_old']);
    unset ($_SESSION['order_dir']);
    unset ($_SESSION['order_field']);
}

$_SESSION['file'] = $file;

// Class Tblc or TblAdvanceC (todo or not)
if (isset($_SESSION['todo'])) {
    require_once 'modul/todo/tbl_advance.class.php';
    $tblc = new Tbl_Advance($use['db_e']);
    $tblc->set_table_order_advance($tbl_ord);
}else{
    $tblc = new Tbl($use['db_e']);
}

// Query class instance
$sql = new Query();

$db = new Dbc($use['db_e']);
require_once 'include/bar_common.inc.php';

// Dustbin
$dbin = new Dustbin( $use['db_e']);
$dbin->set_dustbin($_SESSION['tbl']);

// In case of todo no search_mod
if (isset($_GET['todo'])) {
    unset($_SESSION['search_mod']);
    $limit = 400;
}

if ( isset($_REQUEST['go']) or $_SESSION['tbl'] == 'hou') {
    $_SESSION['value1'] = '';
}

// Change comma to dot, type: double/real
if (isset ($_REQUEST['value1'])) {
    $_SESSION['value1'] =  str_replace(",", ".", $_REQUEST['value1']);
    $_SESSION['value1'] = trim($_SESSION['value1']);
}

// Hint: select address
if (isset ($_GET['new']) and $_GET['new'] == 2) {
    $link_back = link_back_with_query();
    $info_box = $info->show_box($la_address_select);
    $menu = new Menu();
    $search = search_form();
    $menu->add_more_content($search);
    $menu->add_more_content($link_back);
    $menu->print_menu();
    print '</div>';
    exit ();
}

// Hint: Show address inserted
if (isset ($_SESSION['new']) and $_SESSION['new'] == 3) {
    print link_back_with_query();
    print '<div>';
    if (isset($_SESSION['tbl'])) {
        if ($_SESSION['tbl'] == 'ord') {
            $text = $la_order_inserted;
        }elseif($_SESSION['tbl'] == 'adr') {
            $text = $la_address_inserted;
        }elseif($_SESSION['tbl'] == 'exp') {
            $text = $la_expense_inserted;
        }else{
            $text = '';
        }
    }else{
        $text = '';
    }
    $info->show_box($text);
    print '</div>';
    unset($_SESSION['new']);
}

if ($_SESSION['tbl'] == 'hou') {
     $info->show_box($la_hourly_rate_info);
}

// Define tables
$prep = new Query_Prepare();
$prep->get_table_info();
$id_name = $prep->get_id_name();
$order_field = $prep->get_order_field();
$field_as_link = $prep->get_field_as_link();
$table_or_relation = $prep->get_table_or_realation();
$action_new = $prep->get_action_new();
$tbl_new = $prep->get_table_new();
$name_of_hide_field = $prep->get_name_of_hide_field();
$link_target = $prep->get_link_target();
$prep->make_order_dir();
$order_dir = $prep->get_order_dir();

// Set link target
$tblc->set_link_target($link_target);

// make var for field array f.i. 'auf_fel_input'
$fields_for_query =  get_input_output_array('output');

// Fields for query
$sql->set_fields($fields_for_query);
$tblc->set_fields($fields_for_query);


// class menu on/off
$menu = new Menu();

/**
 * Menu x
 */
if ((!isset ($_SESSION['todo']) and !isset ($_REQUEST['todo'])) ) {

    // Search formular for setting value1
    $search = search_form($file);
    $menu->add_more_content($search);

    // New record
    $menu->make_link_new_record();

    // Good filter
    $link_menu = new Link_Menu();
    $arr = array(
        'new' => 1,
        'tbl' => $_SESSION['tbl'], 
        'search_mod' => 2,
        );
    $good_filter = $link_menu->insert_modul('filter', 'query.php', $la_good_filter, $arr);

// Make dropdown for filters
$prep->make_filter_dropdown();

$qry = "SELECT id FROM $tbl WHERE hide = 1";
$menu->show_hidden_records2($qry);

// Todo
}else{
    $content = '<h1 style="padding-left: 2em;">' . $la_todo . '</h1>';
    $menu->add_more_content($content);
}

$menu->print_menu();
    
/**
 * querys for looking in all fields
 */
if (isset ($_SESSION['search_mod']) and $_SESSION['search_mod'] == 1) {
    $where_part = $sql->make_search_string_from_input($_SESSION['value1']);
    $_SESSION['where_part'] = $where_part;

/**
 *  single querys
 */
}elseif (isset ($_SESSION['search_mod']) and $_SESSION['search_mod'] == 2) {
    $hint = new Info_Box();
    $text = 'Erweiterte Suche nicht installiert.';
    $hint->show_box($text);
}

// Make WHERE string
$where_part = $prep->make_where_part();

// Set WHERE string
$sql->set_query_where_part($where_part);
    
// Deleted records
$hide = show_or_hide_deleted_records($name_of_hide_field);

/**
 * Filters
 */
$filter = $prep->make_where_filter();
$sql->set_query_string_where_and($filter);
$sql->set_query_string_where_and($hide);
$sql->set_order_field($order_field);
$sql->set_order_direction($order_dir);

/**
 * Query
 */
if (isset($_REQUEST['geandert']) and $_REQUEST['geaendert'] == 1  ) {
    $query = $_SESSION['query'];
}else{
    $sql->set_table_or_relation($table_or_relation);
    $query = $sql->get_query();
    $query_for_count = $sql->get_query_for_count();
}
$_SESSION['query'] = $query;


// Q U E R Y //////////////////////////////
if ($use['id'] < 3 or $use['id'] == 18) {
    #echo '<p>' . $query . '</p>';
   
}

// Put result to several pages
if (!isset($limit)) {
   $limit = $worker['results_page'];
}
$tblc->set_limit($limit);
$tblc->set_field_as_link($field_as_link);

if ($_SESSION['tbl'] == 'exp' or $_SESSION['tbl'] == 'ord') {
    $tblc->set_total($_SESSION['tbl'] == 'exp' or $_SESSION['tbl'] == 'ord',
         $la_invoice_amount);
}elseif ($_SESSION['tbl'] == 'ord_ite') {
    $tblc->set_total($_SESSION['tbl'] == 'ord_ite', $la_sales_price, $la_amount);
}

// Hide id, if own_doc_number is active
$tblc->unset_field($adm['own_doc_number'] == 1, $la_order_id);
$tblc->set_name_of_delete_field($la_hidden);

// id_name is defined for each table
$tblc->set_id_field($id_name);        
$tblc->set_link_target('order_edit.php', $_SESSION['tbl'] == 'ord_ite');
$tblc->set_link_target('order_edit.php', $_SESSION['tbl'] == 'cal');

$arr7 = array('tbl' => $_SESSION['tbl'], 'file' => $_SERVER['PHP_SELF']);
$tblc->set_link_queryarr($arr7);

$tblc->set_column_width($worker['column_width']);

// No dustbin for calculation
if ($_SESSION['tbl'] == 'cal') {
    $tblc->set_name_of_delete_field('');
}

// Select delivery address
if (isset($_REQUEST['trail1']) and $_REQUEST['trail1'] == 2) {
    $query_string = 'tbl=adr';
    $tblc->set_link2('tbl_edit.php', $query_string, 'Lieferadresse auswhlen');
}

// Tables log, help, convention
$file_for_help = PROJECT_DOCUMENT_ROOT . '/development/query.inc.php';
if (is_file($file_for_help)) {
    require_once $file_for_help;
}

// not table help
if (     $_SESSION['tbl'] != 'hel'
     and $_SESSION['tbl'] != 'con'
     and $_SESSION['tbl'] != 'log'
    ) 
{
    $tblc->set_field_double_width('order_description');
    $tblc->set_query($query);
    $tblc->set_query_count($query_for_count);
    $tblc->set_link_addition($la_edit_for_link_addition);
    $tblc->show_table();
}

HTML::printFoot();
?>
